/**
 * Copyright 2013 Peergreen S.A.S.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.ow2.util.scan.api.metadata;

import java.io.Serializable;
import java.util.List;

import org.ow2.util.scan.api.configurator.IViewConfigurator;
import org.ow2.util.scan.api.metadata.structures.IAnnotation;
import org.ow2.util.scan.api.metadata.structures.IMember;


public interface IMetadata extends Serializable {

    <Annotation> void set(Class<Annotation> annotationClass, Annotation annotation);

    <Annotation> Annotation get(Class<Annotation> annotationClass);

    <T> T getProperty(String name);
    boolean getBoolean(String name);
    <T> void setProperty(String name, T value);

    <T> T as(Class<T> clazz);

    void addViewConfigurator(IViewConfigurator viewConfigurator);

    /**
     * @return undelying object
     */
    IMember getMember();

    /**
     * Defines parent metadata
     */
    void setParent(IMetadata parentMetadata);
    IMetadata getParent();


    void addAnnotation(IAnnotation annotation);
    List<IAnnotation> getAnnotations();

    List<IViewConfigurator> getViewConfigurators();

}
